// BMP1.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <stdlib.h>

typedef unsigned char  byte;    // 8-bitu
typedef unsigned short word;    // 16-bitu
typedef unsigned int   dword;   // 32-bitu

typedef struct _BmpFileHeader
{
  word   FileType;     /* File type, always 4D42h ("BM") */
  dword  FileSize;     /* Size of the file in bytes */
  word   Reserved1;    /* Always 0 */
  word   Reserved2;    /* Always 0 */
  dword  BitmapOffset; /* Starting position of image data in bytes */
} BmpFileHeader;

typedef struct _BitmapHeader
{
  dword Size;            /* Size of this header in bytes */
  dword Width;           /* Image width in pixels */
  dword Height;          /* Image height in pixels */
  word  Planes;          /* Number of color planes */
  word  BitsPerPixel;    /* Number of bits per pixel */
  dword Compression;     /* Compression methods used */
  dword SizeOfBitmap;    /* Size of bitmap in bytes */
  dword HorzResolution;  /* Horizontal resolution in pixels per meter */
  dword VertResolution;  /* Vertical resolution in pixels per meter */
  dword ColorsUsed;      /* Number of colors in the image */
  dword ColorsImportant; /* Minimum number of important colors */
} BitmapHeader;

void VypisPamet(void *adresa, unsigned int delka)
{
  unsigned char *up = (unsigned char *)adresa;
  int x = 0;

  printf("\n**************\nMEMORY: Adresa: %08X, delka: %d (0x%X)\n", adresa, delka, delka);
  for(; delka; delka--)
  {
    printf("%02X ", *up);
    up++;

    x++;
    if (x >= 8)
    {
      x = 0;
      printf("\n");
    }
  }
  printf("\n\n");
}

void BMP(byte *buf, int sirka, int vyska)
{
 int i,j;
 byte *pb, k;
 for (i=0;i<vyska;i++)
   {
   pb=buf+(vyska-i-1)*(sirka/8);
   for (j=0;j<sirka/8;j++)
	{
	 for (k=0x80;k>0;k>>=1)
	  {
	   if (pb[j]&k) putchar(2); else putchar(' ');
	  }
    }
   putchar('\n');
   } 
   
}

int _tmain(int argc, _TCHAR* argv[])
{
  unsigned char data[14];
  BmpFileHeader fh;
  BitmapHeader  bh, *pbh;
  FILE *f;
  pbh=&bh;
//  if (NULL == (f = fopen("lena256gray.bmp", "rb")))
  if (NULL == (f = fopen("intelww4.bmp", "rb")))
  {
    printf("Soubor nelze otevrit\n");
    return -1;
  }

  fread(data, 14, 1 , f);
  VypisPamet(data, 14);
  fseek(f, 0, 0);	
  fread(&fh, sizeof(fh), 1, f);
  VypisPamet(&fh, sizeof(fh));
  printf("FileType:  %c%c (%d, x%04x)\n",
    ((char *)(&(fh.FileType)))[0],
    ((char *)(&(fh.FileType)))[1],
    fh.FileType, fh.FileType);
  printf("FileSize:  %d (x%08x)\n", fh.FileSize, fh.FileSize);
  printf("BmpOffset: %d (x%08x)\n", fh.BitmapOffset, fh.BitmapOffset);

  fread(&bh, sizeof(bh), 1, f);
  VypisPamet(&bh, sizeof(bh));
  printf("Header size:  %d\n", bh.Size);
  printf("Resolution:   %d x %d\n", bh.Width, bh.Height);
  printf("Planes:       %d\n", bh.Planes);
  printf("Bits/px:      %d\n", bh.BitsPerPixel);
  printf("Compression:    %d\n", bh.Compression);
  printf("Size of bitmap: %d\n", bh.SizeOfBitmap);
  printf("ColorsUsed:     %d\n", bh.ColorsUsed);
// ------------------------------------------------------------------
if (pbh->BitsPerPixel != 1)  printf("Umime jen BW obrazky !!\n");
    else
    {
      int velikost = pbh->Width * pbh->Height / 8;
      byte *data = (byte *)malloc(velikost);
      if (data == NULL) printf("Neni pamet\n");
      else
      {
        fseek(f, fh.BitmapOffset, 0);
        fread(data, velikost, 1, f);  
        VypisPamet(data, velikost);
        BMP(data, pbh->Width, pbh->Height);
/*
        int i, j;
        for(j = pbh->Height - 1; j >= 0; j--)
        {
          byte *ptr = data + j * (pbh->Width / 8);
          byte b = 0x80;
          for(i = 0; i < pbh->Width; i++)
          {
            if ((*ptr & b) != 0)
              putchar(2);
            else
              putchar(' ');

            b >>= 1;
            if (b == 0)
            {
              b = 0x80;
              ptr++;
            }
          }
          putchar('\n');
        }
        free(data);
*/        
      }
    }

  fclose(f);
  return 0;
}
