// BMP2.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <stdlib.h>

typedef unsigned char  byte;    // 8-bitu
typedef unsigned short word;    // 16-bitu
typedef unsigned int   dword;   // 32-bitu


typedef struct _BmpFileHeader
{
  word   FileType;     /* File type, always 4D42h ("BM") */
  dword  FileSize;     /* Size of the file in bytes */
  word   Reserved1;    /* Always 0 */
  word   Reserved2;    /* Always 0 */
  dword  BitmapOffset; /* Starting position of image data in bytes */
} BmpFileHeader;

typedef struct _BitmapHeader
{
  dword Size;            /* Size of this header in bytes */
  dword Width;           /* Image width in pixels */
  dword Height;          /* Image height in pixels */
  word  Planes;          /* Number of color planes */
  word  BitsPerPixel;    /* Number of bits per pixel */
  dword Compression;     /* Compression methods used */
  dword SizeOfBitmap;    /* Size of bitmap in bytes */
  dword HorzResolution;  /* Horizontal resolution in pixels per meter */
  dword VertResolution;  /* Vertical resolution in pixels per meter */
  dword ColorsUsed;      /* Number of colors in the image */
  dword ColorsImportant; /* Minimum number of important colors */
} BitmapHeader;

void BMP(byte *buf, int sirka, int vyska)
{
 int i, j, k;
 byte *pb;
 for (i=0;i<vyska;i++)
 {
 pb=buf+(vyska-i-1)*(sirka/8);
 for (j=0;j<sirka/8;j++)
	{
	 for (k=7;k>=0;k--)
		if(pb[j]&(1<<k)) putchar(2); else putchar(' ');
	}
 putchar('\n');
 }

}


void VypisPam(void *pam, int kolik)
{int i;
 unsigned char *buf=(unsigned char*)pam;
 printf("Vypis pameti na adrese %p %d(0x%02X) bajtu\n", pam, kolik,kolik);
 for (i=0;kolik;kolik--)
   {
   printf("%02X ", *buf++);
   i++;
   if(i==8) {i=0;putchar('\n');}
   }
 printf("\n");
}

int _tmain(int argc, _TCHAR* argv[])
{
  
  FILE *f;
  BmpFileHeader fd;
  BitmapHeader bh, *pbh=&bh;
  byte *buf;
  int delka;
//  if (NULL == (f = fopen("lena256gray.bmp", "rb")))
  if (NULL == (f = fopen("intelww4.bmp", "rb")))
  {
    printf("Soubor nelze otevrit\n");
    return -1;
  }

  fread(&fd, sizeof(fd), 1 , f);
  VypisPam(&fd, sizeof(fd));
  printf("FileType:  %04X (%c%c)\n", fd.FileType, ((char *)&fd)[0], ((char *)&fd)[1]);
  printf("FileSize:  %d\n", fd.FileSize);
  printf("Offset:    %d (0x%08X)\n", fd.BitmapOffset, fd.BitmapOffset);

  fread(&bh, sizeof(bh), 1 , f);
  VypisPam(&bh, sizeof(bh));
  printf("Size:         %d\n", pbh->Size); 
  printf("Width:        %d\n", pbh->Width); 
  printf("Height:       %d\n", pbh->Height); 
  printf("BitsPerPixel  %d\n", pbh->BitsPerPixel); 

  delka=pbh->Width*pbh->Height/8;
  buf=(byte *)malloc(delka*sizeof(byte));
  fseek(f, fd.BitmapOffset, 0);
  fread(buf, delka, 1, f);
  BMP(buf, pbh->Width, pbh->Height); 
  fclose(f);

  return 0;
}
